"use strict";

var React = require("react");

var input = React.DOM.input;
module.exports = React.createClass({
  displayName: "app-avatar",
  propTypes: {
    value: React.PropTypes.string.isRequired,
    time: React.PropTypes.number.isRequired,
    onChange: React.PropTypes.func.isRequired,
    style: React.PropTypes.object.isRequired,
    isEditable: React.PropTypes.bool,
    placeholder: React.PropTypes.string
  },
  getDefaultProps: function getDefaultProps() {
    return {
      isEditable: true
    };
  },
  getInitialState: function getInitialState() {
    return {
      value: this.props.value,
      time: this.props.time
    };
  },
  onChange: function onChange(event) {
    if (this.props.isEditable) {
      this.setState({
        value: event.target.value,
        time: new Date().valueOf()
      });
      this.props.onChange(event.target.value, event);
    }

    return undefined;
  },
  render: function render() {
    var lastestValue = this.state.time > this.props.time ? this.state.value : this.props.value;
    return input({
      style: this.props.style,
      value: lastestValue,
      onChange: this.onChange,
      placeholder: this.props.placeholder
    });
  }
});